/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 03/11/2017
 --------------------------------------------------------
*/
package com.portofolio.entity;


import static com.portofolio.base.adapter.DatabaseAdapter.Constant.AKHIR_KURUNG;
import static com.portofolio.base.adapter.DatabaseAdapter.Constant.AWAL_KURUNG;
import static com.portofolio.base.adapter.DatabaseAdapter.Constant.INTEGER;
import static com.portofolio.base.adapter.DatabaseAdapter.Constant.VARCHAR;

import java.util.ArrayList;
import java.util.List;
import java.util.Set;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.Id;
import javax.persistence.Index;
import javax.persistence.JoinColumn;
import javax.persistence.JoinColumns;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Transient;
import javax.persistence.Version;
import javax.validation.constraints.NotNull;

import org.hibernate.annotations.ForeignKey;
import org.hibernate.annotations.Type;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.Setter;


@Entity
@Table(name = "ObjekModulAplikasi_S",indexes = {@Index(name = "ObjekModulAplikasi_S_Index",  columnList="statusEnabled", unique = false) })
@Getter
@Setter
@AllArgsConstructor
@JsonIgnoreProperties({ "hibernateLazyInitializer", "handler" })
public class ObjekModulAplikasi {
	
    private static final String cDefKdObjekModulAplikasi = VARCHAR + AWAL_KURUNG + 36 + AKHIR_KURUNG ;
    @Id
    @Column(name = "KdObjekModulAplikasi",   columnDefinition = cDefKdObjekModulAplikasi)
    @NotNull(message = "objekmodulaplikasiid.kdobjekmodulaplikasi.notnull")
    private String kdObjekModulAplikasi;
    
    private static final String cDefObjekModulAplikasi = VARCHAR + AWAL_KURUNG + 200 + AKHIR_KURUNG ;
    @Column(name = "ObjekModulAplikasi", columnDefinition = cDefObjekModulAplikasi)
    @NotNull(message = "objekmodulaplikasi.objekmodulaplikasi.notnull")
    private String namaObjekModulAplikasi;
    
    private static final String cDefReportDisplay = VARCHAR + AWAL_KURUNG + 200 + AKHIR_KURUNG ;
    @Column(name = "ReportDisplay", columnDefinition = cDefReportDisplay)
    @NotNull(message = "objekmodulaplikasi.reportdisplay.notnull")
    private String reportDisplay;
    
    private static final String cDefDeskripsiObjek = VARCHAR + AWAL_KURUNG + 500 + AKHIR_KURUNG ;
    @Column(name = "DeskripsiObjek", columnDefinition = cDefDeskripsiObjek)
    private String deskripsiObjek;
    
    private static final String cDefKdObjekModulAplikasiHead = VARCHAR + AWAL_KURUNG + 6 + AKHIR_KURUNG ;
    @Column(name = "KdObjekModulAplikasiHead", columnDefinition = cDefKdObjekModulAplikasiHead)
    private String kdObjekModulAplikasiHead;
    
    private static final String cDefAlamatURLFormObjek = VARCHAR + AWAL_KURUNG + 500 + AKHIR_KURUNG ;
    @Column(name = "AlamatURLFormObjek", columnDefinition = cDefAlamatURLFormObjek)
    private String alamatURLFormObjek;
    
    private static final String cDefNoUrutObjek =INTEGER;
    @Column(name = "NoUrutObjek", columnDefinition = cDefNoUrutObjek)
    private Integer noUrutObjek;
    
    private static final String cDefIsMenu =INTEGER;
    @Column(name = "isMenu", columnDefinition = cDefIsMenu)
    private Integer isMenu; 

    private static final String cDefStatusEnabled =INTEGER;
    @Column(name = "StatusEnabled", columnDefinition = cDefStatusEnabled)
    @NotNull(message = "objekmodulaplikasi.statusenabled.notnull")
    @Type(type = "org.hibernate.type.NumericBooleanType") private Boolean statusEnabled;
    
    private static final String cDefNoRec = VARCHAR + AWAL_KURUNG + 36 + AKHIR_KURUNG ;
    @Column(name = "NoRec", columnDefinition = cDefNoRec)
    @NotNull(message = "objekmodulaplikasi.norec.notnull")
    private String noRec;
    
    private static final String cDefVersion =INTEGER;
    @Version
    @Column(name = "version", nullable = false,  columnDefinition = cDefVersion)
    @NotNull(message = "objekmodulaplikasi.version.notnull")
    private Integer version;
    
    //tambahan json ignore biar ga terjadi recursive
    @JsonIgnore
    @ManyToOne(fetch= FetchType.LAZY)
    @JoinColumns({
        @JoinColumn(name="KdObjekModulAplikasiHead", referencedColumnName="KdObjekModulAplikasi",insertable=false, updatable=false),
    })
    //@ForeignKey(name="none")
     private ObjekModulAplikasi objekModulAplikasiHead;
    
    // tambahan untuk recursive
    public ObjekModulAplikasi() {
		this.children = new ArrayList<ObjekModulAplikasi>();
	}
    
    @Transient
    List<ObjekModulAplikasi> children;
    
	public void addChild(ObjekModulAplikasi child) {
		if (!this.children.contains(child) && child != null)
			this.children.add(child);
	}
	
	
	
	//tabahan untuk mapObjekModulToKelompokUser
    @OneToMany(fetch= FetchType.LAZY)
    @JsonIgnore
    @JoinColumns({
        @JoinColumn(name="KdObjekModulAplikasi", referencedColumnName="KdObjekModulAplikasi",insertable=false, updatable=false),
    })
    // //@ForeignKey(name="none")
    Set<MapObjekModulToKelompokUser> mapObjekModulToKelompokUser;
    
    @OneToMany(fetch= FetchType.LAZY)
    @JsonIgnore
    @JoinColumns({
        @JoinColumn(name="KdObjekModulAplikasi", referencedColumnName="KdObjekModulAplikasi",insertable=false, updatable=false),
    })
    // //@ForeignKey(name="none")
    Set<MapModulAplikasiToObjekModul> mapModulAplikasiToObjekModul;


	
}
